function C = form_HZ_C(phi,ep,kappa,xr1,xr2,xall,qr,Psi)
    
  if (qr)
    xqr = prescaleQR(Psi,[xr1(:) xr2(:)]);
    C = RBF_QR_mat_2D(Psi,'L',xqr);
    C = rescale_op(C,Psi.rr,'L');
    C = -C - ...
        kappa^2*RBF_QR_mat_2D(Psi,'1',xqr);
  else
    C = -LapRBF(phi,ep,[xr1(:) xr2(:)],xall) - ...
        kappa^2*RBF(phi,ep,[xr1(:) xr2(:)],xall);
  end

