function [f,Am]=form_HZ_rhs(gfunc,kappa,xs,N,xl,mode)
  f = zeros(N,1);
  nl = size(xl,1);
  x2 = 0;
  g1 = gamma1(x2,gfunc);
  g2 = gamma2(x2,gfunc);
  mu_l = floor(kappa*(g2-g1)/pi);
    
  beta_l = beta(1:mu_l,g1,g2,kappa);
  if (mode==0)
    mvec = 1:mu_l;
  else
    mvec = mode;
  end  
  for m=mvec
    psi_m = psifun(xl(:,1),m,g1,g2); 
    if (mode==0)
      Am(m) = psifun(xs,m,g1,g2);
    else
      Am = 1/sqrt(2);
    end  
    f(1:nl) = f(1:nl) - 2*i*Am(m)*beta_l(m)*psi_m;
    %
    % We cannot trigger modes that do not propagate because they lead to 
    % a ill-posed problem. The boundary conditions cannot see them.
    %
    if (beta_l(m) == 0)
      Am(m) = 0;
    end  
  end  
    

