function [H,H1,H2]=sol_cont(xx1,xx2,sol,fig,ttl)
  if (fig==0)
    H=0; H1=0; H2=0;
    return
  end  
  maxs = max(real(sol));
  mins = min(real(sol));
  h = (maxs-mins)/20;
  v = mins:h:maxs;
  sol = reshape(sol,size(xx1));
  figure(fig), clf

  [C,H]=contourf(xx2,xx1,real(sol),v);
  axis ij
  hold on
  for k=1:length(H)
    set(H,'EdgeColor','none')
  end
  H1(1)=plot(xx2(1,:),xx1(1,:),'k-');
  H1(2)=plot(xx2(end,:),xx1(end,:),'k-');
  H1(3)=plot(xx2(:,1),xx1(:,1),'k-');
  H1(4)=plot(xx2(:,end),xx1(:,end),'k-');
  
  H2=colorbar;
  title(ttl)